function generatePredictionData(n, m, k, density, noise, minSize, sizeInc, sizeIters, nInstances, dataName)
% Find size range.
sizeLevels = nan(sizeIters, 1);
for i = 1 : sizeIters
    sizeLevels(i) = minSize + (i-1)*sizeInc;
end

% Generate data.
for i = 1 : sizeIters
    for j = 1 : nInstances
        B = randi([1,10], n, k);
        C = randi([1,10], k, m);
        Bmask = rand(size(B)) < density;
        Cmask = rand(size(C)) < density;
        Borig{i}{j} = B .* Bmask;
        Corig{i}{j} = C .* Cmask;
        Aorig{i}{j} = MaxProduct(Borig{i}{j}, Corig{i}{j});
        Anoisy{i}{j} = Aorig{i}{j};
        % Add noise.      
        targetDensity = nnz(Aorig{i}{j}) / numel(Aorig{i}{j});
        noisePattern = rand(size(Aorig{i}{j})) < noise * targetDensity;
        N = rand(size(Aorig{i}{j}));
        Anoisy{i}{j}(noisePattern) = N(noisePattern);
        AnoisyBeforeHoldout{i}{j} = Anoisy{i}{j};
        % Holdout set.
        nonzer = find(Aorig{i}{j});
        H{i}{j} = nonzer(rand(numel(nonzer), 1) < sizeLevels(i));  
        Anoisy{i}{j}(H{i}{j}) = nan;
    end
end

save(dataName, 'Aorig', 'Anoisy', 'AnoisyBeforeHoldout', 'H', 'Borig', 'Corig');

end

